declare default element namespace "http://www.tei-c.org/ns/1.0";

(:
Returns <nym/> entry with its id and <oth/> as label
:)
declare function local:listOccupation($nym){
  let $id:= $nym/@xml:id
  let $labText:=($nym/orth)[1]//text()[not(ancestor::note)]
  let $name := normalize-space(if($labText) then string-join($labText,' ') else string($id)) 
  return <entry xml:id='{$id}'>
  {$name}
  {for $subNym in $nym/nym return local:listOccupation($subNym)}
  </entry>
};

(:
Lists all occupations in an index resource document
:)               
declare function local:listOccupations($indexDocumentPath){
    <toc>{for $i in doc($indexDocumentPath)//listNym/nym  return local:listOccupation($i)}</toc>
};

