declare default element namespace "http://www.tei-c.org/ns/1.0";
(:
 Returns <Person/> entry with first persName as label and occupations
as sub entries.
:)
declare function local:listPerson($element){
    let $id:=$element/@xml:id
    let $labtag:=($element//persName)[1]//text()[not(ancestor::note)]
    let $name := normalize-space(if($labtag) then string-join($labtag,' ') else string($id))
    return
        <entry xml:id='{$id}'>
            {$element/@*:lock}{$name}
            {local:listOccupations($element)}
        </entry>
};

(:
Gets a person occupation list
:)
declare function local:listOccupations($p){
    for $o in $p//occupation
    return <entry>{$o/@xml:id}{normalize-space(string-join($o//text()[not(ancestor::note)],' '))}</entry>
};

(:
Lists all persons from a specified collection path
:)               
declare function local:listPersons($collection){
    <toc>{for $i in collection($collection)//TEI  return local:listPerson($i)}</toc>
};