declare default element namespace "http://www.tei-c.org/ns/1.0";

(:
 Returns <place/> entry with first placeName as label and sub places
as sub entries.
:)
declare function local:listPlace($element){
    let $id:=$element/@xml:id
    let $labtag:=($element//placeName)[1]//text()[not(ancestor::note)]
    let $name := normalize-space(if($labtag) then string-join($labtag,' ') else string($id))
    return 
        <entry xml:id='{$id}'>
            {$element/@*:lock}{$name}
            {local:subPlaces($element/text/body/listPlace/place[1])}
        </entry>
};

(:
Gets a place sub places list
:)
declare function local:subPlaces($p){
    for $subPlace in $p/place
    return <entry>{$subPlace/@xml:id}{normalize-space(string-join($subPlace/placeName[1]//text()[not(ancestor::note)],' '))}</entry>
};

(:
Lists all places from a specified collection path
:)
declare function local:listPlaces($collection){
    <toc>{for $i in collection($collection)//TEI  return local:listPlace($i)}</toc> 
};