declare default element namespace "http://www.tei-c.org/ns/1.0";

(:Returns ' - ' + bibl author name if exists:)
declare function local:getAuthorInfo($bibl){  
   if($bibl/author)
   then concat(' - ', normalize-space(string-join($bibl/author/name//text(),' ')))
   else()
};

(: Returns a bibl label: its firt title:)
declare function local:getLabel($bibl){
   let $labtag:=($bibl//title)[1]//text()[not(ancestor::note)]
   return normalize-space(if($labtag) then concat(string-join($labtag,' '), local:getAuthorInfo($bibl)) else string($bibl/@xml:id))
};

(:
 Returns a bibl as a toc entry
:)
declare function local:listBibl($bibl){
    let $id:=$bibl/@xml:id
    return
        <entry xml:id='{$id}'>
              
            {local:getLabel($bibl)}
            {for $subWork in $bibl/bibl return local:listBibl($subWork)}
            
        </entry>
};

(:
Returns a TEI work as a toc entry
:)
declare function local:listMainWork($element){
   let $id:=$element/@xml:id
   let $mainBibl := $element//body/listBibl/bibl
    return
        <entry xml:id='{$id}'>
              
            {$element/@*:lock}{local:getLabel($mainBibl)}
            {for $subWork in $mainBibl/bibl return local:listBibl($subWork)}
            
        </entry>
};



(:
Lists all works and sub works from a specified collection path
:)               
declare function local:listWorks($collection){
    <toc>{for $i in collection($collection)//TEI  return local:listMainWork($i)}</toc>
};